var gDoneButton;
var growboxInset;
var gInfoButton;
var scrollArea, scrollbar;
var gMensaURL = "http://www.stwh-portal.de/mensa/index.php?wo=2&wann=1&format=txt";
var lastHeight;
var lastWidth;

function setup()
{
	gDoneButton = new AppleGlassButton(document.getElementById("doneButton"), "Done", hidePrefs);

	gInfoButton = new AppleInfoButton(document.getElementById("infoButton"), document.getElementById("front"), "black", "black", showPrefs);

	scrollbar = new AppleVerticalScrollbar(document.getElementById("myScrollBar"));

	scrollArea = new AppleScrollArea(document.getElementById("plan"), scrollbar);

	scrollArea.scrollsHorizontally = false;
	//scrollArea.singlepressScrollPixels = 25;
	scrollArea.focus();

	window.onfocus = function () { scrollArea.focus(); };
	window.onblur = function () { scrollArea.blur(); };
	widget.onshow = loadPage;
	widget.onremove = removePrefs;

	if(window.widget)		// always check to make sure that you are running in Dashboard
	{
		// The preferences are retrieved:
		var mensaURL = widget.preferenceForKey(makeKey("mensaURL"));
		if(mensaURL !== undefined)
		{
			if(mensaURL.search(/www.studentenwerk-hannover.de/) != -1)
			{
				mensaURL = gMensaURL;
				widget.setPreferenceForKey(gMensaURL, makeKey("mensaURL"));
			}
		}
		else
		{
			widget.setPreferenceForKey(gMensaURL, makeKey("mensaURL"));
		}
		var entrySelected = widget.preferenceForKey(makeKey("entrySelected"));

		var windowWidth = widget.preferenceForKey(makeKey("windowWidth"));
		var windowHeight = widget.preferenceForKey(makeKey("windowHeight"));

		if(windowWidth !== undefined)
		{
			window.resizeTo(windowWidth, windowHeight);
		}

		if (mensaURL && mensaURL.length > 0)  // if the retrieved preferences are not empty,
		{	
			gMensaURL = mensaURL;
		}
		//if(entrySelected.length > 0)
		//{
		   // (document.getElementById("mensaChoser")).options.selectedIndex = entrySelected;
		   // (document.getElementById("mensaChoser")).options[entrySelected].selected = true;
		 //  document.getElementById("mensaChoser").selectedIndex = entrySelected;
		//}
		document.getElementById("mensaChoser").selectedIndex = entrySelected;


	   // (document.getElementById("mensaChoser")).options.selectedIndex = 3;
	}

	loadPage();
}

function changeMensa(elem)
{	
	gMensaURL = elem.value;

	if(window.widget)
	{
		widget.setPreferenceForKey(gMensaURL, makeKey("mensaURL"));
		widget.setPreferenceForKey(elem.selectedIndex, makeKey("entrySelected"));
		//document.getElementById("itemChosed").innerHTML = elem.selectedIndex;
	}
} 

function removePrefs()
{
	widget.setPreferenceForKey(null, makeKey("mensaURL"));
	widget.setPreferenceForKey(null, makeKey("entrySelected"));
}

function showPrefs()
{
	lastHeight = window.innerHeight;
	lastWidth = window.innerWidth;


	window.resizeTo(300,230);

	var front = document.getElementById("front");

	var back = document.getElementById("back");

	if (window.widget)
		widget.prepareForTransition("ToBack");

	front.style.display="none";

	back.style.display="block";


	if (window.widget)

		setTimeout ('widget.performTransition();', 0);  

	document.getElementById('fliprollie').style.display = 'none';

}

function hidePrefs()
{


	var front = document.getElementById("front");

	var back = document.getElementById("back");


	if (window.widget)

		widget.prepareForTransition("ToFront");



	back.style.display="none";

	front.style.display="block";


	if (window.widget)

		setTimeout ('widget.performTransition();', 0);

	loadPage();

	if(window.widget)
	{
		var windowWidth = widget.preferenceForKey(makeKey("windowWidth"));
		var windowHeight = widget.preferenceForKey(makeKey("windowHeight"));

		window.resizeTo(parseInt(windowWidth, 10), parseInt(windowHeight, 10));
	}  

}

function mouseDown(event)

{



	document.addEventListener("mousemove", mouseMove, true);

	document.addEventListener("mouseup", mouseUp, true);



	growboxInset = {x:(window.innerWidth - event.x), y:(window.innerHeight - event.y)};



	event.stopPropagation();

	event.preventDefault();

}



function mouseMove(event)

{



	var x = event.x + growboxInset.x;

	var y = event.y + growboxInset.y;

	if (x < 300) x = 300;
	if (y < 230) y = 230;

	document.getElementById("resize").style.top = (y-12);

	window.resizeTo(x,y);

	if(window.widget)
	{
		widget.setPreferenceForKey(window.outerWidth, makeKey("windowWidth"));
		widget.setPreferenceForKey(window.outerHeight, makeKey("windowHeight"));
	}

	event.stopPropagation();

	event.preventDefault();

}





function mouseUp(event)

{

	document.removeEventListener("mousemove", mouseMove, true);

	document.removeEventListener("mouseup", mouseUp, true); 



	event.stopPropagation();

	event.preventDefault();

}

function showLoading()
{
	document.getElementById("plan").innerHTML = "loading...";
}

function occurrences(string, substring){

	var n=0;
	var pos=0;

	while(true){
		pos=string.indexOf(substring,pos);
		if(pos!=-1){ n++; pos+=substring.length;}
		else{break;}
	}
	return(n);
}

/* MensaH Script */
function loadPage()
{
	var currentTextValue = document.getElementById("plan");
	var req = new XMLHttpRequest();
	var del_legende = [];
	var speise = "";
	var speiseplan_array = [];
	var speiseplan_line_array = [];
	var speiseplan = "";
	var speiseplan_line = [];
	var speiseplan_line_string = "";
	var i = 0;
	var j = 0;

	req.open("GET", gMensaURL, true);
	req.send("");

	req.onreadystatechange=function()
	{
		if (req.readyState==4) 
		{
		   if (req.status == 200)
		   { 
				if(req.status != 304)
				{
					if((req.responseText).search(/\bgeschlossen\b/) == -1)
					{
						del_legende = (req.responseText).split("- LEGENDE:"); // Legende löschen
						speise = del_legende[0].replace(/>/g, ""); // Pfeil am Anfang löschen
						speise = speise.replace(/#/g, ""); // Trenner löschen
						speise = speise.replace(/\|/g, "-");
						//speise = speise.replace(/Wahlmenü:/, "Wahlmenü");

						// Zusätze ersetzen    
						speise = speise.replace(/\(g\)/gi, "<span class='ingred'>g</span>");
						speise = speise.replace(/\(s\)/gi, "<span class='ingred'>s</span>");
						speise = speise.replace(/\(r\)/gi, "<span class='ingred'>r</span>");
						speise = speise.replace(/\(v\)/gi, "<span class='ingred'>v</span>");
						speise = speise.replace(/\(j\)/gi, "<span class='ingred'>j</span>");
						speise = speise.replace(/\(a\)/gi, "<span class='ingred'>a</span>");
						speise = speise.replace(/\(f\)/gi, "<span class='ingred'>f</span>");
						speise = speise.replace(/\(n\)/gi, "<span class='ingred'>n</span>");
						speise = speise.replace(/\(k\)/gi, "<span class='ingred'>k</span>");

						speise = speise.replace(/(\([0-9]{1,2}\))+/g, "");
						var prices = speise.match(/\s[0-9]{1},[0-9]{2}€/g);
						for(var x in prices)
						{
							var anzahl = occurrences(speise, prices[x]);
							for(var i = 0; i < anzahl; i++)
							{
								var price = prices[x].replace(/ /, "");
								speise = speise.replace(prices[x], "<br>"+price);
							}
						}


					   // speise = speise.replace(/[0-9]{1},[0-9]{2}€/[0-9]{1},[0-9]{2}€/[0-9]{1},[0-9]{2}€/g, "

						speiseplan_array = speise.split("\n"); // einzelne Speisen trennen (da immer eine Zeile pro Speise)

						speiseplan = speiseplan_array[1]+": "+speiseplan_array[3]+"<br><hr>"; // Formatierung hinzufügen
						// 1 ist Name der Mensa, 3 das Datum

						i=4; // da vorher nur Ueberschriften und Leerzeilen
						while (i < speiseplan_array.length)
						{
							if(speiseplan_array[i].length > 0) // wir wollen keine Leerzeilen
							{
								speiseplan_line_array = speiseplan_array[i].split(":"); // Ueberschrift von Gericht trennen
								if(speiseplan_line_array[0] !== undefined && speiseplan_line_array[1] !== undefined)
								{
									if(speiseplan_line_array[2] !== undefined)
									{
										speiseplan_line[i] = "<i>"+speiseplan_line_array[0]+"</i><br>"+speiseplan_line_array[1]+"<br>"+speiseplan_line_array[2]+"<br>"; // Zwischenüberschriften
									}
									else
									{
										speiseplan_line[i] = "<i>"+speiseplan_line_array[0]+"</i><br>"+speiseplan_line_array[1]+"<br>"; // Zwischenüberschriften
									}
								}
								else if (speiseplan_line_array[i] !== "" )
								{
									speiseplan_line[i] = speiseplan_line_array.join("");
								} 
							}
							i++;
						 }

						 j=0;
						 while(j < speiseplan_line.length)
						 {
							 if(speiseplan_line[j] !== undefined)
							 {
							 	speiseplan_line_string = speiseplan_line.join("<br>");
								j++;
							}
							else
							{  		
								speiseplan_line.shift();
							}

						}

						currentTextValue.innerHTML = speiseplan+speiseplan_line_string;
						scrollArea.refresh();
					}
					else
					{
						currentTextValue.innerHTML = "<b>Diese Mensa hat heute geschlossen.</b>";
						scrollArea.refresh();
					}
				}
			}
		}
		else
		{
		   currentTextValue.innerHTML = "running";
			scrollArea.refresh();
		}
	}
}

function makeKey(key)
{
	return (widget.identifier + "-" + key);
}